local indexedDB = window.indexedDB or window.mozIndexedDB or window.webkitIndexedDB or window.msIndexedDB;
local IDBTransaction = window.IDBTransaction or window.webkitIDBTransaction or window.msIDBTransaction;
local IDBKeyRange = window.IDBKeyRange or window.webkitIDBKeyRange or window.msIDBKeyRange;

local function open(name, version, setup)
	local co = coroutine.running()
	local request = indexedDB:open(name, version)
	function request:onerror(event)
		print("ERROR")
		coroutine.resume(co,nil,event)
	end
	function request:onupgradeneeded(event)
		setup(event.target.result, event)
	end
	function request:onsuccess(event)
		coroutine.resume(co,request.result)
	end
	return assert(coroutine.yield(request))
end

coroutine.resume(coroutine.create(function()
	print("STARTING")
	local db = open("My DB",5,function(db)
		local os = db:createObjectStore("users", JS{ autoIncrement = true })
	end)
	print("DONE!")
end))